<?php
// controller/SimpleDispatcher.php
// qframe license: http://resources.corrosive.co.uk/pkg/qframe/license.txt

require 'Dispatcher.php';

class SimpleDispatcher extends Dispatcher {
   private $dispatchHash = array();

   function addCondition( $cmd, $target, $status=-1 ) {
       $cmd = strtolower( $cmd );
       if ( $status > 0 ) {
          $this->dispatchHash[ "$cmd.$status" ] = $target;
       } else {
         $this->dispatchHash[ "$cmd" ] = $target;
       }
   }

   function getNext( RequestHelper $helper ) {
       list( $cmd, $status ) = array_pop( $helper->getCommandArray() );
       $cmd = strtolower( $cmd );
       $key = "$cmd.$status";
       $view = $this->dispatchHash[$key];
       if ( empty( $view ) ) {
          $view = $this->dispatchHash[$cmd];
       }
       return $view;
   }
}
?>
