<?php
  class DateIterator {
      public static $ADAY = 86400;
      private $pointer;
    
      function __construct( $month, $day, $year ) {
        $this->pointer= mktime(0,0,0,$month,$day,$year);
      }
    
      function incrementDay() {
        $this->pointer += (DateIterator::$ADAY);
      } 
     
      function getMonthStartWDay() {
        $date_array = $this->getPointerArray();
        $date = mktime ( 0, 0, 0,
                        $date_array['mon'], 1,
                        $date_array['year'] );
        $array = getdate( $date );
        return $array['wday'];
      }
    
      function getPointer() {
        return $this->pointer;
      }
    
      function getPointerArray() {
        $array = getDate( $this->pointer );
        $array['month'] = strftime ( "%B", $array[0] );
        return $array;
      }
    }
?>
