<?php
  $GLOBALS['slength']  = 30;
  $GLOBALS['dbres']    = connect( "data/testdb" );
  $GLOBALS['visit_id'] = $_COOKIE['visit_id'];
  $GLOBALS['user_stats'];
 
  if ( empty( $GLOBALS['visit_id'] ) ) {
      $GLOBALS['user_stats'] = newuser( );
      print "<p> ,  !</p>";
  } else {
      print "<p>   " . $GLOBALS['visit_id'] . "!</p>";
      $GLOBALS['user_stats'] = olduser( $GLOBALS['visit_id'] );
  }

  function newuser( ) {
    $visit_data = array (  
                  'first_visit'    => time(),
                  'last_visit'     => time(),
                  'num_visits'     => 1,
                  'total_duration' => 0,
                  'total_clicks'   => 1
                  );

    insert_visit( $visit_data );
    setcookie( "visit_id", $visit_data['id'],
                time()+(60*60*24*365*10), "/" );
    return $visit_data;
  }

  function olduser( $visit_id ) {
    $now = time();
    $visit_data = get_visit( $visit_id );
    if ( ! $visit_data ) {
       return newuser( );
    }
    $visit_data['total_clicks']++;
    if ( ( $visit_data['last_visit'] + $GLOBALS['slength'] ) > $now ) {
           $visit_data['total_duration'] +=
                ( $now - $visit_data['last_visit'] );
    } else {
       $visit_data['num_visits']++;
    }
    $visit_data['last_visit'] = $now;
    update_visit( $visit_data );
    return $visit_data;
  }

  function connect( $db ) {
    $dbres = sqlite_open($db, 0, $error);
    if ( ! is_resource( $dbres ) ) {
        die( " Sqllite: $error" );
    }
    $create = "CREATE TABLE track_visit (
               id             INTEGER PRIMARY KEY,
               first_visit    INTEGER,
               last_visit     INTEGER,
               num_visits     INTEGER,
               total_duration INTEGER,
               total_clicks   INTEGER)";
    @sqlite_query( $dbres, $create );
    return $dbres;
  }

  function get_visit( $visit_id ) {
    $query  = "SELECT * FROM track_visit WHERE id=$visit_id";
    $result = sqlite_query( $GLOBALS['dbres'], $query );
  
    if ( ! sqlite_num_rows( $result ) ) {
        return false;
    }
    return sqlite_fetch_array( $result, SQLITE_ASSOC );
  }
 
  function update_visit( &$visit_data ) {
    $update_pairs = array();
    foreach( $visit_data as $field => $val ) {
      if ( ! is_int( $field ) ) {
          array_push( $update_pairs, "$field=$val" );
      }
    }
    $query  = "UPDATE track_visit SET ";
    $query .= implode( ", ", $update_pairs );
    $query .= " WHERE id=" . $visit_data['id'];
    sqlite_query( $GLOBALS['dbres'], $query );
  }

  function insert_visit( &$visit_data ) {
    $query  = "INSERT INTO track_visit ( ";
    $query .= implode( ", ", array_keys( $visit_data ) );
    $query .= " ) VALUES( ";
    $query .= implode(", ", array_values( $visit_data ) );
    $query .= " );";
    $result = sqlite_query( $GLOBALS['dbres'], $query );
    $visit_data['id'] = sqlite_last_insert_rowid( $GLOBALS['dbres'] );
  }
?>
