<?php
  require_once "Auth/Auth.php";
 
  $GLOBALS['LEGAL_FUNCS'] = array( "main", "signup", "logout" );
  $GLOBALS['PAGE']['AUTH'] = new Auth("File", "../data/passfile.txt", "write_login" );
  $GLOBALS['PAGE']['msg'] = "";
 
  switchboard();

  function switchboard() {
     $comms = $GLOBALS['LEGAL_FUNCS'];
     $cmd   = $_REQUEST['cmd'];
     if ( empty($cmd) || ! in_array( $cmd, $comms) ) {
         $cmd = $comms[0];
     }
     $page = $cmd();
     if ( ! empty( $page ) ) {
         @include( $page );
     }
  }

  function setMessage( $msg ) {
     $GLOBALS['PAGE']['msg'] .= "$msg<br />";
  }

//   ///////////////////////

  function authenticate() {
     $auth = $GLOBALS['PAGE']['AUTH'];
     $auth->start();
     if ( ! $auth->getAuth() ) {
        exit();
     }

     return true;
  }

  function write_login() {
     $auth = $GLOBALS['PAGE']['AUTH'];
     if ( $auth->getStatus() == AUTH_EXPIRED ) {
        setMessage("  ");

     } else if ( $auth->getStatus() == AUTH_WRONG_LOGIN ) {
        setMessage(" .     .");

     }
     // include login
     include_once( "listing23.1.php" );
  }

//     ///////////////////////

  function signup() {
     if ( empty( $_REQUEST['username'] ) ) {
     //   
         return "listing23.signup.php";
     }
     $signup = $GLOBALS['PAGE']['AUTH']->addUser(
               $_REQUEST['username'], $_REQUEST['password'] );
     if ( $signup instanceof pear_error ) {
          setMessage( $signup->message );
     //   
      return "listing23.signup.php";
     }
     setMessage( " ." );
     return main();
   }

 function logout() {
     $auth=$GLOBALS['PAGE']['AUTH'];
     authenticate();
     $auth->logout();
     setMessage($auth->getUsername() . "  .");
     return write_login();
 }

 function main() {
     authenticate();
 //   
    return "listing23.main.php";
 }
?>
