<!DOCTYPE HTML PUBLIC
  "-//W3C//DTD XHTML 1.0 Strict//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html>
 <head>
  <title> 9.5.     </title>
 </head>
 <body>
  <div>
   <?php
      class WrongClass { }

      class ItemLister {
         private $items = array();

         function addItem( $item ) {
            if ( !is_a ( $item, "Item" ) ) {
               die( "   Item" );
            }
            array_push( $this->items, $item );
         }

         function splurgeItems() {
            foreach( $this->items as $item ) {
            print $item->getProductString();
            print "<br />";
            }
         }
      }


      class Item {
         private $name;
         private $code;
         private $productString;
   
         function Item( $name = "Item", $code = 0 ) {
            $this->code = $code;
            $this->setName( $name );
         }
     
         function getProductString() {
            return $this->productString;
         }
     
         function setName( $n ) {
            $this->name = $n;
            $this->makeProductString( $n, $this->code );
         }

         private function makeProductString( $string, $code) {
            return $this->productString = "$string $code";
         }

         function getName() {
            return $this->name;
         }
      }

     class PriceItem extends Item {
        private $price;

        function __construct( $name, $code, $price ) {
           parent::__construct( $name, $code );
           $this->price = $price;
        }

        function getName() {
           return "() " . parent::getName();
        }
     }



      $lister = new ItemLister();
      $lister->addItem( new PriceItem("Item", 3456, 1.56) );
      $lister->addItem( new Item("Item1",1) );
      $lister->addItem( new PriceItem("Item123", 123456, 21.16) );
      $lister->splurgeItems();

   ?>
  </div>
 </body>
</html>
