<?php
// controller/RequestHelper.php
// qframe license: http://resources.corrosive.co.uk/pkg/qframe/license.txt

require '../command/DataStore.php';

class RequestHelper {
   private $params       = array();
   private $commandArray = array();
   private $datastore;

   function RequestHelper( ) {
       $this->datastore = DataStore::getInstance();
       $this->params = $_REQUEST;
   }

   function getCommand() {
       return $this->params['cmd'];
   }

   function overrideParams( $params ) {
       $this->params = $params;
   }

   function getOrigParams() {
       return $_REQUEST;
   }

   function getParams() {
       return $this->params;
   }

   function saveVar( $name, $value ) {
       $this->datastore->setVar( $name, $value );
   }

   function getVar( $name ) {
       return $this->datastore->getVar( $name );
   }

   function getVars() {
       return $this->datastore->getVars();
   }

   function setMessage( $message ) {
       $this->datastore->setMessage( $message );
   }

   function registerCommand( $name, $status ) {
       $this->commandArray[] = array( $name, $status );
   }

   function getCommandArray() {
       return $this->commandArray;
   }
}
?>
