<?php
  setLocale(LC_ALL, "ru_RU.CP1251");
  include_once( "listing16.5.php" );
  include_once( "listing16.6.php" );

  $cal = new QuickCalendar(  $_REQUEST['month'],
                             $_REQUEST['year']   );
  $current = $cal->getCurrentArray( );
?>

<!DOCTYPE html PUBLIC
  "-//W3C//DTD XHTML 1.0 Strict//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html>
 <head>
  <title> <?php print $current['month'] . " " .
                               $current['year' ] ?></title>
 </head>
 <body>

  <h1> <?php print $current['month'] . " " .
                            $current['year' ] ?></h1>
   
  <form method="post" action="<?php echo $_SERVER['PHP_SELF'] ?>">
   <div>
    <select name="month">
       <?php print DateViewHelper::monthPulldown($current['mon'] ); ?>
    </select>

    <select name="year">
       <?php print DateViewHelper::yearPulldown( 1980, 2010, $current['year'] ); ?>
    </select>
   
    <input type="submit" value="" />
   </div>
  </form>

    <table border="1" cellpadding="5">
      <tr><td><b>
    <?php print implode( "</b></td><td><b>", DateViewHelper::$DAYS ); ?>
      </b></td></tr>
    <tr>
<?
    while ( ! is_null( $cell = $cal->nextCell() ) ) {
      if ( empty( $cell ) ) {
        print "<td> - </td>";
      } else {
        print "<td>" . $cell['mday' ] . " "
                     . $cell['month'] . "</td>";
      }
      if ( $cal->endOfRow() && ! $cal->endOfGrid() ) {
        print "</tr><tr>";
      }
    }
    ?>
    </tr>
    </table>
 </body>
</html>
