<?php
 
 class Item {
   const DISCONTINUED    = 1;
   const PROMOTIONAL     = 2;
   const STOCKED_OFFSITE = 4;
   private $status       = 0;

   public function addStatus( $num ) {
      $this->status |= $num;
   }

   public function isPromotional() {
      return(Item::PROMOTIONAL&$this->status)?true:false;
   }

   public function isDiscontinued() {
      return(Item::DISCONTINUED&$this->status)?true:false;
   }

   public function isOffsiteItem() {
      return(Item::STOCKED_OFFSITE&$this->status)?true:false;
   }
 }

 $item = new Item();
 $item->addStatus( Item::STOCKED_OFFSITE );
 $item->addStatus( Item::PROMOTIONAL );
 $item->addStatus( Item::DISCONTINUED );

 if ( $item->isOffsiteItem() ) {
     print "  .    4 ";
 }
?>
