<?php

 class Grepper {
   private static $descriptors = array( 
                         0 => array( "pipe", r ),
                         1 => array( "pipe", w ),
                         2 => array( "pipe", w )
                       );

   static function grep ( $in, $arg ) {
      $proc = proc_open( "grep $arg", self::$descriptors, $pipes );

      if ( ! is_resource( $proc ) ) {
          throw new Exception( " proc_open()   " );
      }

      fwrite( $pipes[0], $in );
      fclose( $pipes[0] );

      while ( ! feof( $pipes[1] ) ) {
        $ret .= fgets($pipes[1], 1024);
      }

      fclose( $pipes[1] );

      try {
          self::checkError( $pipes[2] );
      } catch( Exception $e ) {
          throw $e;
      }

      proc_close( $proc );
      return $ret;
   }

   static private function checkError( $pipe ) {
      $ret = "";
      while ( ! feof( $pipe ) ) {
          $ret .= fgets( $pipe );
      }
      fclose( $pipe );
      if ( $ret ) {
         throw new Exception( $ret );
      }
      return false;
     }
   }

   $string  = "   .\n";
   $string .= "  --   .\n";
   $string .= "    .\n";
   $string .= "    -- .\n";

   try {
       print ( Grepper::grep( $string, "" ));
   } catch ( Exception $e ) {
       print "error: " . $e->getMessage();
   }
?>
