<?php
require_once("Config.php");
$root_container = new Config_Container("section", "forum-configuration");
$root_container->createDirective( "forum-name", "Matt's Forum" );

$perm_sec = $root_container->createSection("permissions");
$perm_sec->createDirective("allow-html-tags", "no");
$perm_sec->createDirective("uploads", "55");
$perm_sec->createDirective("allow-pictures", "yes");

$content_sec = $root_container->createSection("content");
$content_sec->createDirective("filter-obscenity", "no");
$content_sec->createDirective("inlude-newsfeeds", "yes");

$conf = new Config();
$conf->setRoot( $root_container );
$conf->writeConfig("./data/out.txt", "inifile" );

?>