<?php
// my_commands/AddTask.php
// qframe license: http://resources.corrosive.co.uk/pkg/qframe/license.txt

require_once "../command/Command.php";
require_once "../my_commands/MyDefault.php";
require_once "../facade/TaskFacade.php";

class AddTask extends Command {

  function doExecute( RequestHelper $requestHelper ) {

      $params = $requestHelper->getParams();

      if ( empty( $params['addtask_submit'] ) ) {
           $params = $requestHelper->setMessage("  ");
           return CMD_UNPROCESSED;
      }

      if (  empty( $params['summary'] ) ||
            empty( $params['person']  ) ) {
            $requestHelper->setMessage("  ");
            return CMD_ERROR;
      }
      $taskfacade = new TaskFacade();
      $taskfacade->setTask( $params );
      $cmd = new MyDefault();
      return $cmd->execute( $requestHelper );
   }
}
?>
